cdac.medinfo.sdk.hl7282.baselibs.segments

## Class QAK

- java.lang.Object
- - cdac.medinfo.sdk.hl7282.baselibs.segments.Segment
  - - cdac.medinfo.sdk.hl7282.baselibs.segments.QAK

- All Implemented Interfaces:
    ISegment

      public class QAK
      extends Segment

  QAK - Query Acknowledgment Segment.

  QAK segment contains information sent with responses to a query. Although the QAK segment is required in the responses to the enhanced queries it may appear as an optional segment placed after the (optional) ERR segment in any query response (message) to any original mode query.

  Represents an HL7 QAK message segment. This segment has the following fields:

  QAK-1: Query Tag (ST)Conditional
  QAK-2: Query Response Status (ID)Optional
  QAK-3: Message Query Name (CWE)Optional
  QAK-4: Hit Count (NM)Optional
  QAK-5: This payload (NM)Optional
  QAK-6: Hits remaining (NM)Optional

  This class provides mechanism to validate message against HL7 v 2.8.2 standard. The class provides accessors & mutators for the elements mentioned above. The class has validate method which validates Message against HL7 v 2.8.2 standard.

  User can also create Segment through `SegmentFactory`

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `QAK()` Constucts the QAK segment.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `NM` | `getHitCountTotal()` Retrieves the Hit Count Total.
    `NM` | `getHitsremaining()` Retrieves the Hits remaining.
    `CWE` | `getMessageQueryName()` Retrieves the Message Query Name.
    `ID` | `getQueryResponseStatus()` Retrieves the Query Response Status.
    `ST` | `getQueryTag()` Retrieves the Query Tag.
    `NM` | `getThispayload()` Retrieves the This payload.
    `void` | `setHitCountTotal(NM objhitCount)` Set the Hit Count Total.
    `void` | `setHitCountTotal(java.lang.String strHitCountTotal)` Set the Hit Count Total.
    `void` | `setHitsremaining(NM objhitsremaining)` Set the Hits remaining.
    `void` | `setHitsremaining(java.lang.String strHitsremaining)` Set the Hits remaining.
    `void` | `setMessageQueryName(CWE objmessageQueryName)` Set the Message Query Name.
    `void` | `setMessageQueryName(java.lang.String strIdentifier, java.lang.String strText, java.lang.String strNameOfCodingSystem, java.lang.String strAlternateIdentifier, java.lang.String strAlternateText, java.lang.String strNameOfAlternateCodingSystem, java.lang.String strCodingSystemVersionID, java.lang.String strAlternateCodingSystemVersionId, java.lang.String strOriginalText, java.lang.String strSecondAlternateIdentifier, java.lang.String strSecondAlternateText, java.lang.String strNameofSecondAlternateCodingSystem, java.lang.String strSecondAlternateCodingSystemVersionID, java.lang.String strCodingSystemOID, java.lang.String strValueSetOID, java.lang.String strValueSetVersionID, java.lang.String strAlternateCodingSystemOID, java.lang.String strAlternateValueSetOID, java.lang.String strAlternateValueSetVersionID, java.lang.String strSecondAlternateCodingSystemOID, java.lang.String strSecondAlternateValueSetOID, java.lang.String strSecondAlternateValueSetVersionID)` Set the Message Query Name.
    `void` | `setQueryResponseStatus(ID objqueryResponseStatus)` Set the Query Response Status.
    `void` | `setQueryResponseStatus(java.lang.String strQueryResponseStatus)` Set the Query Response Status.
    `void` | `setQueryTag(ST objqueryTag)` Set the Query Tag.
    `void` | `setQueryTag(java.lang.String strQueryTag)` Set the Query Tag.
    `void` | `setThispayload(NM objthispayload)` Set the This payload.
    `void` | `setThispayload(java.lang.String strThispayload)` Set the This payload.
    `boolean` | `validate()` Validates HL7 Message objects .

    - ### Methods inherited from class cdac.medinfo.sdk.hl7282.baselibs.segments.Segment

      `addUnRecognizedField, dumpSegment, getFields, getName, getUnrecognizedFields, moveToNextSegment, parse, removeDataElement, removeDataElement, serialize, setName, setUnRecognizedField, updateDataElement, updateDataElement, writeToXML`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### QAK

          public QAK()

      Constucts the QAK segment.

  - ### Method Detail

    - #### getHitCountTotal

          public NM getHitCountTotal()

      Retrieves the Hit Count Total. This field contains the total number of records found by the Server that match the query.
      Returns:
        NM - hitCount

    - #### getHitsremaining

          public NM getHitsremaining()

      Retrieves the Hits remaining. This field contains the number of matching records found by the Server that have yet to be sent.
      Returns:
        NM - hitsremaining

    - #### getMessageQueryName

          public CWE getMessageQueryName()

      Retrieves the Message Query Name.
      Returns:
        CWE - messageQueryName

    - #### getQueryResponseStatus

          public ID getQueryResponseStatus()

      Retrieves the Query Response Status. This field allows the responding system to return a precise response status.
      Returns:
        ID - queryResponseStatus

    - #### getQueryTag

          public ST getQueryTag()

      Retrieves the Query Tag. This field value by the initiating system to identify the query and use to match response messages to the originating query.
      Returns:
        ST - queryTag

    - #### getThispayload

          public NM getThispayload()

      Retrieves the This payload. This field contains the total number of matching records that the Server sent in the current response.
      Returns:
        NM - thispayload

    - #### setHitCountTotal

          public void setHitCountTotal(java.lang.String strHitCountTotal)

      Set the Hit Count Total. This field contains the total number of records found by the Server that match the query.
      Parameters:
        `strHitCountTotal` - Contains the total number of records found by the Server that matched the query.

    - #### setHitCountTotal

          public void setHitCountTotal(NM objhitCount)

      Set the Hit Count Total. This field contains the total number of records found by the Server that match the query.
      Parameters:
        `objhitCount` - object of Hit Count Total.

    - #### setHitsremaining

          public void setHitsremaining(java.lang.String strHitsremaining)

      Set the Hits remaining. This field contains the number of matching records found by the Server that have yet to be sent.
      Parameters:
        `strHitsremaining` - Contains the number of matching records found by the Server that have yet to be sent.

    - #### setHitsremaining

          public void setHitsremaining(NM objhitsremaining)

      Set the Hits remaining. This field contains the number of matching records found by the Server that have yet to be sent.
      Parameters:
        `objhitsremaining` - object of Hits Remaining.

    - #### setMessageQueryName

          public void setMessageQueryName(java.lang.String strIdentifier,
                                 java.lang.String strText,
                                 java.lang.String strNameOfCodingSystem,
                                 java.lang.String strAlternateIdentifier,
                                 java.lang.String strAlternateText,
                                 java.lang.String strNameOfAlternateCodingSystem,
                                 java.lang.String strCodingSystemVersionID,
                                 java.lang.String strAlternateCodingSystemVersionId,
                                 java.lang.String strOriginalText,
                                 java.lang.String strSecondAlternateIdentifier,
                                 java.lang.String strSecondAlternateText,
                                 java.lang.String strNameofSecondAlternateCodingSystem,
                                 java.lang.String strSecondAlternateCodingSystemVersionID,
                                 java.lang.String strCodingSystemOID,
                                 java.lang.String strValueSetOID,
                                 java.lang.String strValueSetVersionID,
                                 java.lang.String strAlternateCodingSystemOID,
                                 java.lang.String strAlternateValueSetOID,
                                 java.lang.String strAlternateValueSetVersionID,
                                 java.lang.String strSecondAlternateCodingSystemOID,
                                 java.lang.String strSecondAlternateValueSetOID,
                                 java.lang.String strSecondAlternateValueSetVersionID)

      Set the Message Query Name.
      Parameters:
        `strIdentifier` - Specifies of characters (the code) that uniquely identifies the item being referenced.
        `strText` - Specifies The descriptive or textual name of the identifier, e.g., myocardial infarction.
        `strNameOfCodingSystem` - Identifies the coding scheme being used in the identifier component.
        `strAlternateIdentifier` - Specifies an alternate sequence of characters (the code) that uniquely identifies the item being referenced.
        `strAlternateText` - Specifies the descriptive or textual name of the alternate identifier. See usage note in section introduction.
        `strNameOfAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strCodingSystemVersionID` - A sequence of characters that uniquely identifies a second alternate code.
        `strAlternateCodingSystemVersionId` - This component carries the version for the coding system identified by components 4-6.
        `strOriginalText` - The text as seen and/or selected by the user who entered the data.
        `strSecondAlternateIdentifier` - A sequence of characters that uniquely identifies a second alternate code.
        `strSecondAlternateText` - The descriptive or textual name of the alternate identifier.
        `strNameofSecondAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strSecondAlternateCodingSystemVersionID` - This component carries the version for the coding system identified by components 10-12.
        `strCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.3.
        `strValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.1 is obtained.
        `strValueSetVersionID` - This component carries the version for the value set identified by CWE.15. The version is a date. The date is the date/time that the value set being used was published.
        `strAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.6.
        `strAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.4 is obtained.
        `strAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.18. The version is a date.
        `strSecondAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.12.
        `strSecondAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.10 is obtained.
        `strSecondAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.21. The version is a date.

    - #### setMessageQueryName

          public void setMessageQueryName(CWE objmessageQueryName)

      Set the Message Query Name.
      Parameters:
        `objmessageQueryName` - object of message Query Name.

    - #### setQueryResponseStatus

          public void setQueryResponseStatus(java.lang.String strQueryResponseStatus)

      Set the Query Response Status. This field allows the responding system to return a precise response status.
      Parameters:
        `strQueryResponseStatus` - Use as QueryResponseStatus.

    - #### setQueryResponseStatus

          public void setQueryResponseStatus(ID objqueryResponseStatus)

      Set the Query Response Status. This field allows the responding system to return a precise response status.
      Parameters:
        `objqueryResponseStatus` - object of Query Response Status.

    - #### setQueryTag

          public void setQueryTag(java.lang.String strQueryTag)

      Set the Query Tag. This field value by the initiating system to identify the query and use to match response messages to the originating query.
      Parameters:
        `strQueryTag` - Use as QueryTag.

    - #### setQueryTag

          public void setQueryTag(ST objqueryTag)

      Set the Query Tag. This field value by the initiating system to identify the query and use to match response messages to the originating query.
      Parameters:
        `objqueryTag` - object of Query Tag.

    - #### setThispayload

          public void setThispayload(java.lang.String strThispayload)

      Set the This payload. This field contains the total number of matching records that the Server sent in the current response.
      Parameters:
        `strThispayload` - Contains the total number of matching records that the Server sent in the current response.

    - #### setThispayload

          public void setThispayload(NM objthispayload)

      Set the This payload. This field contains the total number of matching records that the Server sent in the current response.
      Parameters:
        `objthispayload` - object of This payload.

    - #### validate

          public boolean validate()
                           throws InvalidSegmentException

      Validates HL7 Message objects . Validate method checks for validation each and every segments in side the Message object against specified message Structure. Validation chcecks include optionality of segment or group. It also verifies the number of times segment or group is repeated in message. e.g {PSH} while parsing PSH segment validate method will check for its mandatory presence. [PSH] in this case validate will throw exception if one tries to enter more than one PSH segment.
      Specified by:
        `validate` in interface `ISegment`
      Overrides:
        `validate` in class `Segment`
      Returns:
        boolean - true or false.
      Throws:
        `InvalidSegmentException` - Throws when Segment Validation fails.